	subroutine Dropshaft_general(tf,Dt,R)
	!Purpose: To compute fluxes and flow depth at 
	!each dropshaft. Dropshafts are assumed to be located upstream. 
	use common_module 
	implicit none		       
	integer n,r,j,Idb,Id1,sum
	integer conver_result,info,node_pressur
	integer flowcaseIA1,FLOW_REGIA1,cond_mixed
	doubleprecision fvec(3), x(3)	  
	double precision P_phob,AIA,TsIA,RHIA,Wpred
	doubleprecision Ab,yb,Qb,F11,F12
	doubleprecision u11,Q11,temp1,temp3
	doubleprecision tf,Dt,test,der_P_phoIA,P_pho
	doubleprecision c11,y11,A11,P_pho11,hdropsh	
	doubleprecision AA,Ts,RH,AL,AR
	doubleprecision y,A,AStar,Qstar
	doubleprecision Qinflow,Qinf_new,Qinf_old,Ares
	doubleprecision con1,con2,con3,tol_const_state
	doubleprecision k1,dr,Ref_level,yres
	doubleprecision temp_con1,temp_con2,temp_con3,temp_con4,temp_con5
	doubleprecision Qsum,Error_y
	doubleprecision yw0,Aw0,Qw0,FF1,FF2,yL,YR,QL,QR
	integer CODL, Idf0	
	external dropsh	

	!To enforce that the minimum water depth at pond is ydropmin(R)
	if (yres_jun_old(R) < ydropmin(R))then
		yres_jun_old(R) = ydropmin(R)	
	endif
	j = NodeID(R,1)
	dr = Drop(R,1)		
	tol_const_state = TOL_VERY_LOW*d(j)
	call get_inflow(R,tf,Qinf_old)
	call get_inflow(R,tf+Dt,Qinf_new)
	
	!volume balance
	If(code_vol_bal == 1 .or. code_vol_bal == -1)then !Volume balance
		Qinflow = (Qinf_old+Qinf_new)/2d0
		Vol_bal = Vol_bal + vol_factor*Qinflow*Dt	
		If(code_vol_bal == -1)then !Volume balance		
			Qinf_old = (1d0-vol_factor)*Qinf_old
			Qinf_new = (1d0-vol_factor)*Qinf_new
		elseif(code_vol_bal == 1)then !Volume balance		
			Qinf_old = (1d0+vol_factor)*Qinf_old
			Qinf_new = (1d0+vol_factor)*Qinf_new
		endif
	endif
	
	Ares = Ares_junct(R)
	!Local head loss coefficient	
 	if (Nodetype(R,1) == 2)then !outflowing  
		K1 = Klocal(j,1)	
	elseIf(Nodetype(R,1) == 1)then
		K1 = Klocal(j,2)
	else
		write(99,*),'Nodetype .ne. 1,2'
		write(99,*),'Subr. Dropshaft_general'
		call endprog
	endif	

5	if (Nodetype(R,1) == 2)then !outflowing
		A11 = A0(j,3); Q11 = Q0(j,3); Id1 = Idflow(j,3)
		y11 = h0(j,3)
		Ab_oldIA(1) = Abound(j,1); Qb_oldIA(1) = Qbound(j,1)
		yb_oldIA(1) = ybound(j,1)
		IDfbIA_old(1) = Idflow_bound_reser(j,1)
	Elseif (Nodetype(R,1) == 1)then !inflowing
		A11 = A0(j,Nx(j)-2);Q11 = Q0(j,Nx(j)-2);Id1 = Idflow(j,Nx(j)-2)
		y11 = h0(j,Nx(j)-2)
		Ab_oldIA(1) = Abound(j,2); Qb_oldIA(1) = Qbound(j,2)
		yb_oldIA(1) = ybound(j,2)
		IDfbIA_old(1) = Idflow_bound_reser(j,2)
	Else
		write(99,*),'Nodetype(R,1) .ne. 1,2'
		write(99,*),'Subr. Dropshaft_general'
		call endprog
	Endif

	!To check if the cells that surround the node are pressurized
	!1: pressurized, 0 free surface flow	
	if(Id1 == 1)then	
		node_pressur = 1
	else
		node_pressur = 0
	endif

	!To determine FLOW_REGIA1,flowcaseIA1
	call Freesurface_flowregime(R,j,dr,Id1,IDfbIA_old(1),Idb,Q11,y11,
     & A11,FLOW_REGIA1,flowcaseIA1,Nodetype(R,1),
     & cond_mixed,node_pressur,sum,yw01(1),Aw01(1),Qw01(1),Idf01(1))

	!if (cond_mixed == 1)then
	!	cond_mixed = 5
	!	sum = 2
	!	flowcaseIA1 = 2
	!	IDfbIA_old(1) = 1
	!	Idb = 1
	!	Id1 = 1
	!	y11 = yres_jun_old(R)-Drop(R,1)
	!	call Area_from_H(j,y11,A11,Ts,RH,Id1)
	!	if (Nodetype(R,1) == 1)then !inflowing
	!		Q11 = Q0(j,Nx(j)-2)
	!		h0(j,Nx(j)-2) = y11; A0(j,Nx(j)-2) = A11
	!		Idflow(j,Nx(j)-2) = Id1
	!	elseif (Nodetype(R,1) == 2)then !outflowing
	!		Q11 = Q0(j,3)
	!		h0(j,3) = y11; A0(j,3) = A11; Idflow(j,3) = Id1
	!	else
	!		write(99,*),'Pipe is not inflowing or outflowing'
	!		write(99,*),'Check the input data'
	!		write(99,*),'subrout. junction_general'
	!		call endprog
	!	endif								
	!endif

	!if (cond_mixed == 4)then
	!	cond_mixed = 100
	!	sum = 0
	!	flowcaseIA1 = 2
	!	IDfbIA_old(1) = 0
	!	Idb = 0
	!	Id1 = 0
	!	y11 = max(yres_jun_old(R)-Drop(R,1),ydry(j))		
	!	call Area_from_H(j,y11,A11,Ts,RH,Id1)
	!	if (Nodetype(R,1) == 1)then !inflowing
	!		Q11 = Q0(j,Nx(j)-2)
	!		h0(j,Nx(j)-2) = y11; A0(j,Nx(j)-2) = A11
	!		Idflow(j,Nx(j)-2) = Id1
	!	elseif (Nodetype(R,1) == 2)then !outflowing
	!		Q11 = Q0(j,3)
	!		h0(j,3) = y11; A0(j,3) = A11; Idflow(j,3) = Id1
	!	else
	!		write(99,*),'Pipe is not inflowing or outflowing'
	!		write(99,*),'Check the input data'
	!		write(99,*),'subrout. junction_general'
	!		call endprog
	!	endif
	!endif

	u11=Q11/A11
	call Pressure_Pho(j,y11,P_pho11,Id1)
	If (Id1==0)then
		call Area_from_H(j,y11,AA,Ts,RH,Id1)
		c11 = sqrt(g*A11/Ts)
	else
		c11 = pc1(j)
	endif
	
	!To check if we need to solve the equations at the boundary or not
!	if (sum == 0)then
!		if (y11 < (1d0+tol_higher)*ydry(j) .and. yres_jun_old(R) < 
!     &			(1d0+tol_higher)*ydropmin(R))then
!			!Flux computation
!			F11 = 0d0; F12 = 0d0
!			if (Nodetype(R,1) == 2)then !outflowing
!				Abound(j,1) = Adry(j); Qbound(j,1) = 0d0
!				ybound(j,1) = ydry(j);Idflow_bound(j,1) = Idb
!				Fupst(j,1) = F11; Fupst(j,2) = F12
!			Elseif (Nodetype(R,1) == 1)then !inflowing
!				Abound(j,2) = Adry(j); Qbound(j,2) = 0d0
!				ybound(j,2) = ydry(j); Idflow_bound(j,2) = Idb
!				Fdownst(j,1) = F11;	Fdownst(j,2) = F12
!			Endif 
!			temp3 = 5d-1*(Qinf_new+Qinf_old)
!			yres = yres_jun_old(R) + temp3*dt/Ares 					
!			yres_jun_old(R) = yres
!			goto 200
!		endif
!	endif

!	If (sum == 2)then
!		!Pure pressurized flow	      	       						
!		con1 = sqrt(4d0*Ares/PI) !diameter equiv. dropsh.
!		con2 = g*PI*4d0**(1d0/3d0)*con1**(2d0/3d0)*
!     &		nm(j)**2d0/(Ares**2d0)	
!		param14 = con2     		   	      			
!	endif

	!solving equations: free surface, pressurized and combined
  	!Pure free surface flow or combined 
	param1 = A11; param2 = Q11; param3 = c11; param4 = y11
	param7 = dt; param8 = k1
	param9 = Ares; param10 = Qinf_new; param11 = Qinf_old

	parint1 = j; parint2 = sum; parint3 = R
	parint4 = Idb; parint5 = flowcaseIA1
	parint6 = FLOW_REGIA1	
	parint7	= cond_mixed	
	n = 3
	yres =  yres_jun_old(R)
	x(1:n) = (/y11,yres,Q11/)

	parint1000 = 0
	call hybrd1 (dropsh, n, x, fvec, TOL_lower, info)
	call converg (conver_result,info)
	If(conver_result == 1 .or. parint1000 == 1)then	
		parint1000 = 0		
		!write(99,*),'sum_no_converg',sum_no_converg
		If(cond_mixed == 4 .or. cond_mixed == 2)then
			write(99,*),'cond_mixed = 4 or 2, Subr. Dropsh_gen, node',R			
			!goto 14
			!Computing direction of mixed flow interface
!			if (Nodetype(R,1) == 2)then !outflowing	
!				YL = yres_jun_old(r)-Drop(R,1)
!				call Area_from_H(j,YL,AL,Ts,RH,0)
!				QL = 0d0
!				yR = y11; AR = A11; QR = Q11
!				CODL = 0
!				temp_con5 = (Aref(j)-AL)*dx(j)
!				call interf_speed(AL,AR,QL,QR,Wpred)
!				if (Wpred > -0.01)then
!					 goto 12
!				else
!					goto 14
!				endif						
!			else	!inflowing
!				yL = y11; AL = A11; QL = Q11
!				YR = yres_jun_old(r)-Drop(R,1)
!				call Area_from_H(j,YR,AR,Ts,RH,0)
!				QR = 0d0
!				CODL = 1
!				temp_con5 = (Aref(j)-AR)*dx(j)
!				call interf_speed(AL,AR,QL,QR,Wpred)
!				if (Wpred < 0.01)then
!					goto 12
!				else
!					goto 14
!				endif	
!			endif
!
!			!Depressurization using criteria of Benjamin
! 12			y = max(yres_jun_old(r)-Drop(R,1),0.5978*d(j))				
!			yb = y
!			call Area_from_H(j,yb,A,Ts,RH,0)	
!			if (yres_jun_old(r) < 0.5978*d(j))then
!				if (Nodetype(R,1) == 2)then !outflowing						
!					Qb = -1.328*A*sqrt(g*A/Ts)
!				else !inflowing
!					Qb = 1.328*A*sqrt(g*A/Ts)
!				endif
!			else
!				!max. flow to be sent to pond
!				temp_con1 = yref(j) - (yres_jun_old(r)-Drop(R,1))
!				temp_con2 = Ares*temp_con1/dt
!				if (Nodetype(R,1) == 2)then !outflowing						
!					Qb = -min(1d0*A*sqrt(g*A/Ts),temp_con2)
!				else !inflowing
!					Qb = min(1d0*A*sqrt(g*A/Ts),temp_con2)
!				endif
!			endif				
!			Idb = 0			

			yb = yw01(1)
			Qb = Qw01(1)
			Idb = Idf01(1)
			goto 18
!		elseIf(cond_mixed == 2)then	
!			write(99,*),'cond_mixed = 2, Subr. Dropsh_gen, node',R	
!14			yb =  y11
!			temp_con2 = 0.5*dx(j)/dt
!			if (y11 +Drop(R,1) > yres_jun_old(R))then
!				temp_con4 = Drop(R,1)+ d(j)/2d0
!				temp_con1=y11+Drop(R,1)-max(yres_jun_old(R),temp_con4)
!			else
!				temp_con1 = 0d0
!			endif
!			!To make sure that as maximum 50% of the volume from the adjacent 
!			!cell would enter the reservoir. 			
!			temp_con3 = 0.4*sqrt(2d0*g*temp_con1)
!			if (Nodetype(R,1) == 2)then !outflowing					
!				Qb = -A11*min(temp_con2,temp_con3)
!				!Negative sign because flow is entering the reservoir
!			else	!inflowing			
!				Qb = A11*min(temp_con2,temp_con3)			
!			endif
!			Idb = 1
		elseif(cond_mixed == 1)then
			write(99,*),'cond_mixed = 1, Subr. Dropsh_gen., node',R
			yb =  y11
			!flow in adjacent cell is free surface and 
			!water level at pond is above pipe crown (pressur. flow)						
			temp_con4 = yres_jun_old(R)-Drop(R,1)- y11 !0.5*(y11+yref(j))			
			temp_con2 = Ares_junct(R)*temp_con4/
     &			(A11*dt)
			!if (yres_jun_old(r)-Drop(R,1) < 1.2*Yref(j))then
			!	temp_con1 = 0d0
			!else
				temp_con1 = yres_jun_old(R)-Drop(R,1)-y11/2d0
			!endif
			if (temp_con1 <= 0d0)then
				temp_con1 = 0d0
			endif

			temp_con3 = 0.4*sqrt(2d0*g*temp_con1)

			if(yres_jun_old(R)-Drop(R,1)-y11 < 0d0)then
				temp_con2 = 0d0 
			endif

			!To make sure that as maximum 50% of the volume from the adjacent 
			!cell would enter the reservoir. 					
			
			if (Nodetype(R,1) == 2)then !outflowing
				Qb = A11*min(temp_con2,temp_con3) 
				!Negative sign because flow is entering the reservoir
			else !inflowing				
				Qb = -A11*min(temp_con2,temp_con3)
			endif
			Idb = 0
		else
			write(99,*),'No conv. Subr. Dropsh_gen., node',R
			yb = y11; Qb = Q11; Idb = Id1
		endif

 18		if (Nodetype(R,1) == 2)then !outflowing
			!sign for Qb is negative for upstream reservoir
			temp1 = -Qb 
		Elseif (Nodetype(R,1) == 1)then !inflowing
			temp1 = Qb
		Endif		
		temp3 = 5d-1*(Qinf_new+Qinf_old)
		yres = yres_jun_old(R) + (temp3+temp1)*dt/Ares 	
	else	
		yb = x(1); yres = x(2); Qb = x(3)
		if (cond_mixed == 1)then ! .or. cond_mixed == 4)then
			Idb = 0
		elseif (cond_mixed == 2 .or. cond_mixed == 4)then
			Idb = Idf01(1)
		endif				
	endif

!30    continue

	!For depressurization of the pond in case of mixed flow conditions
30	if (cond_mixed == 1)then !For cond_mixed == 1
		if (yres < (Drop(R,1)+yref(j)))then
			if (Nodetype(R,1) == 1)then !inflowing
				Idflow_bound_reser(j,2) = 0
			else
				Idflow_bound_reser(j,1) = 0
			endif
		endif			
	endif

	If (ISNAN(yres))then 
		write(99,*),'NaN is found in Yreservoir' 
		write(99,*),'Yres',Yres
		write(99,*),'Subr. dropshaft'
		call endprog
	endif

	write(99,*),'tf',tf
!	write(99,*),'j,Node2(j)',j,Node2(j) 
	!Downstream partially open valve (Trajkovic)	
!	if (Node2(j) == 2)then
!	write(99,*),'j,Node2(j)',j,Node2(j) 
		if (tf >= 30d0)then	
			yb = h0(j,Nx(j)-2)		
			Ab = A0(j,Nx(j)-2)
			y = 0.028 !gate opening: modify
			call Area_from_H(j,y,Ar,Ts,RH,0)
			if (yb < 0.83*y)then
				Qb = 0d0
			else
				Qb = 0.78*Ar*sqrt(2d0*g*(yb - 0.83*y))
			endif
			call Pressure_Pho(j,yb,P_phob,Idflow(j,Nx(j)-2))		
			Fdownst(j,1) = Qb
			Fdownst(j,2) = Qb**2d0/Ab + P_phob
			Abound(j,2) = Ab; Qbound(j,2) = Qb
			ybound(j,2) = yb
			Idflow_bound(j,2) = Idflow(j,Nx(j)-2)
			yres_jun_old(R) = yb
			Error_y = 0d0
			goto 200
		endif
!	endif
	!Flux computation
 	call Area_from_H(j,yb,Ab,Ts,RH,Idb)
	call Pressure_Pho(j,yb,P_phob,Idb) 
	F11 = Qb; F12 = Qb**2d0/Ab + P_phob
 40	if (Nodetype(R,1) == 2)then !outflowing
		Abound(j,1) = Ab; Qbound(j,1) = Qb
		ybound(j,1) = yb;Idflow_bound(j,1) = Idb
		Fupst(j,1) = F11; Fupst(j,2) = F12
	Elseif (Nodetype(R,1) == 1)then !inflowing
		Abound(j,2) = Ab; Qbound(j,2) = Qb
		ybound(j,2) = yb; Idflow_bound(j,2) = Idb
		Fdownst(j,1) = F11;	Fdownst(j,2) = F12
	Endif 

	!Mass balance check at every node
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	Qsum = 0d0	
	if (Nodetype(R,1) == 1)then !inflowing
		Qsum = Qsum + Qb
	else !outflowing
		Qsum = Qsum - Qb
	endif
!	
	temp_con3 = 5d-1*(Qinf_new+Qinf_old)
	temp_con4 = yres_jun_old(R) + (temp_con3+Qsum)*dt/Ares
	Error_y = abs(yres-temp_con4)/(0.5*(temp_con4+yres))
	Error_y = Error_y*100.0
	Error_y = 0d0  !added
	if (Error_y > 0.1)then
		write(99,*),'Node, Error_y', R, Error_y
	endif

	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	yres_jun_old(R) = yres
200	return	
      end

	!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
	subroutine dropsh(n,x,fvec,iflag)
	use common_module
	implicit none	
	integer n,iflag,r,j,Idb,Id1,flowcaseIA1,FLOW_REGIA1
	integer sum,cond_mixed
	doubleprecision fvec(n),x(n)
	doubleprecision AIA,TsIA,RHIA,u11,Q11,temp1,temp3,temp4,temp8	
	doubleprecision Qinf_new,Qinf_old,Ares,y11,A11,P_pho11,cb1,c11
	doubleprecision Qb,Ab,ub,yb,ub1,dt,cb,Tb,RH,yres
	doubleprecision con1,con2,con3,con4,con5,Qs,k1,y,A,Ts
	doubleprecision temp_con1,temp_con2,temp_con3,temp_con4

	parint1000 = 0
	A11 = param1; Q11= param2; c11 = param3; 
	y11 = param4; dt = param7
	k1 = param8; Ares = param9; Qinf_new = param10
	Qinf_old = param11
	j = parint1; sum = parint2; R = parint3
	Idb = parint4
	flowcaseIA1 = parint5; FLOW_REGIA1 = parint6
	cond_mixed = parint7
	u11 = Q11/A11
	if(cond_mixed .ne. 1 .and. cond_mixed .ne. 2 
     &	.and. cond_mixed .ne. 4)then
		If (Idb == 0)then
			temp8 = (yref(j)+d(j))/2d0
			If (x(1) >= temp8)then			
				x(1) = temp8
				parint1000 = 1 
			endif
			If (x(1) < 0.5*ydry(j))then	
				x(1) = 0.5*ydry(j)
				parint1000 = 1 
			endif
			call Area_from_H(j,x(1),Ab,Tb,RH,0)
			cb = sqrt(g*Ab/Tb)
		elseif (Idb == 1)then
			call Area_from_H(j,x(1),Ab,Tb,RH,1)
		else
			write(99,*),'Idb undefined in routine Dropshaft_general'
			call endprog
		endif
		!x(1) = yb yres = x(2); Qb = x(3)			
		ub = x(3)/Ab	

		if (Nodetype(R,1) == 2)then !outflowing
			if (sum == 2)then		
				fvec(1) = ub - pc1(j)*LOG(Ab) - (u11 - pc1(j)*LOG(A11))
			elseif (sum == 0)then			
				fvec(1) = ub - u11 - (cb + c11)*(Ab - A11)/(Ab + A11)
			else
				parint1000 = 1 
			endif
		Elseif (Nodetype(R,1) == 1)then !inflowing
			if (sum == 2)then
				fvec(1) = ub + pc1(j)*LOG(Ab) - (u11 + pc1(j)*LOG(A11))
			elseif (sum == 0)then 
				fvec(1) = ub - u11 + (cb + c11)*(Ab - A11)/(Ab + A11)
			else
				parint1000 = 1
			endif
		endif
	endif
	!con1 = (x(2))**2d0/(2d0*g*AIA**2d0) 
	!con2 = x(2)*abs(x(2))/(2d0*g*AIA**2d0)
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	!Constant state, critical flow, normal flow,pressurized/freefall	
	if (sum == 0)then 
		if (Nodetype(R,1) == 2)then !outflowing
			If(flowcaseIA1 == 1)then !free outfall or normal flow 
				If(FLOW_REGIA1 == 10)then
					!negative sign for critical depth (negative flow)					
					fvec(2) = -ub - cb
				elseif(FLOW_REGIA1 == 11)then
					!Riemann invariants can not be used for outflowing 
					!pipes and supercritical flows					
					!fvec(1) = x(2)-Drop(R,1)-x(1)
					!positive sign for critical depth (positive flow)
	
					fvec(1) = x(2)-Drop(R,1)-x(1)
					fvec(2) = ub - cb
				else
					write(99,*),'# of FLOW_REGIA1 is not supported'
					write(99,*),'Routine Dropshaft_general'
					call endprog
				endif
			elseIf (flowcaseIA1 == 2)then !Constant head
				fvec(2) = x(2)-Drop(R,1)-x(1)
			else
				!If the flow is supercritical in the outflowing pipe
				!we may have critical flow at the boundary (posit.) 
				!direction. We can add this later.
				write(99,*),'flowcaseIA1 is not supported'
				write(99,*),'Routine Dropshaft_general'
				call endprog
			endif
		elseIf(Nodetype(R,1) == 1)then !inflowing 
			If(flowcaseIA1 == 1)then	!free outfall or normal flow 
				!free outfall or normal flow 
				If(FLOW_REGIA1 == 1)then	!critical flow
					fvec(2) = ub - cb
				elseif(FLOW_REGIA1 == 2)then !normal flow
					fvec(2) = ub - 1d0/nm(j)*
     &			RH**(2d0/3d0)* sqrt(S0(j))
				else
					write(99,*),'# of FLOW_REGIA1 is not supported'
					write(99,*),'Routine Dropshaft_general'
					call endprog
				endif
			elseIf (flowcaseIA1 == 2)then !Constant head
				fvec(2) = x(2)-Drop(R,1)-x(1)
				!con1 = (x(3))**2d0/(2d0*g*Ab**2d0) 
				!con2 = x(3)*abs(x(3))/(2d0*g*Ab**2d0)			
				!fvec(2) = x(1) + con1 + k1*con2 - (x(2)-Drop(R,1))  !Energy equation
			else
				write(99,*),'flowcaseIA1 is not supported'
				write(99,*),'Routine Dropshaft_general'
				call endprog
			endif	
		else
			write(99,*),'Nodetype(R,1) .ne. 1,2'
			write(99,*),'Routine Dropshaft_general'
			call endprog
		endif
	elseif (sum == 2)then
			If(flowcaseIA1 == 2)then					
				fvec(2) = x(2)-Drop(R,1)-x(1)
			else
				write(99,*),'11,sum,flowcaseIA(j)',sum,flowcaseIA1
				write(99,*),'flowcaseIA1 undef. in subr. Dropshaft_general'
				call endprog
			endif
	else
		If(cond_mixed == 4 .or. cond_mixed == 2)then
			fvec(1) = x(1) - yw01(1)
			fvec(2) = x(3) - Qw01(1)	

			!y = max(yres_jun_old(r)-Drop(R,1),0.5978*d(j))				
			!fvec(1) = x(1) - y
			!call Area_from_H(j,y,A,Ts,RH,0)	
			!if (yres_jun_old(r) < 0.5978*d(j))then
			!	if (Nodetype(R,1) == 2)then !outflowing											
			!fvec(2) = x(3) + 1.328*A*sqrt(g*A/Ts)
			!	else !inflowing
			!fvec(2) = x(3) - 1.328*A*sqrt(g*A/Ts)
			!	endif
			!else
			!	!max. flow to be sent to pond
			!	temp_con1 = yref(j) - (yres_jun_old(r)-Drop(R,1))
			!	temp_con2 = Ares*temp_con1/dt
			!	if (Nodetype(R,1) == 2)then !outflowing	
			!fvec(2) = x(3) + min(1d0*A*sqrt(g*A/Ts),temp_con2)
			!	else !inflowing
			!fvec(2) = x(3) - min(1d0*A*sqrt(g*A/Ts),temp_con2)
			!	endif
			!endif
		!elseIf(cond_mixed == 2)then
		!	fvec(1) = x(1) - y11
		!	!temp_con2 = min(0.5*dx(j)/dt,temp_con5/(A11*dt))
		!	temp_con2 = 0.5*dx(j)/dt
		!	if (y11+Drop(R,1) > yres_jun_old(r))then
		!		temp_con4 = Drop(R,1)+ d(j)/2d0
		!		temp_con1 = y11+Drop(R,1)-
     &	!			max(yres_jun_old(r),temp_con4)
		!	else
		!		temp_con1 = 0d0
		!	endif
		!	!To make sure that as maximum 50% of the volume from the adjacent 
		!	!cell would enter the reservoir. 					
		!	temp_con3 = 0.2*sqrt(2d0*g*temp_con1)
		!	if (Nodetype(R,1) == 2)then !outflowing						
		!		fvec(2) = x(3) + A11*min(temp_con2,temp_con3) 
		!		!Negative sign because flow is entering the reservoir
		!	else	!inflowing															
		!		fvec(2) = x(3) - A11*min(temp_con2,temp_con3)
		!	endif
		elseif(cond_mixed == 1)then
			!flow in adjacent cell is free surface and 
			!water level at pond is above pipe crown (pressur. flow)			
			temp_con4 = x(2)-Drop(R,1)- y11  !yref(j)     !-0.5*(y11+yref(j))
			temp_con1 = x(2)-Drop(R,1)-y11/2d0
			temp_con2 = Ares_junct(R)*temp_con4/
     &			(A11*dt)

			if(x(2)-Drop(R,1)-y11 < 0d0)then
				temp_con2 = 0d0 
			endif

			if(temp_con1<0d0)then
				write(99,*),'temp_con1 < 0. Subr. Dropshaft_general'
				call endprog
			endif
			!To make sure that as maximum 50% of the volume from the adjacent 
			!cell would enter the reservoir. 					
			temp_con3 = 0.4*sqrt(2d0*g*temp_con1)							
			if (Nodetype(R,1) == 2)then !outflowing
				!fvec(1) = ub-u11-(cb+c11)*(Ab-A11)/(Ab + A11)
				fvec(1) = x(1) - y11
				fvec(2) = x(3) - A11*min(temp_con2,temp_con3) 
				!Negative sign because flow is entering the reservoir
			else	!inflowing
				!fvec(1) = ub-u11+(cb+c11)*(Ab-A11)/(Ab+A11)					
				fvec(1) = x(1) - y11
				fvec(2) = x(3) + A11*min(temp_con2,temp_con3)
			endif
		elseif(cond_mixed == 3)then
			parint1000 = 1 
		else
			write(99,*),'cond_mixed not supported'
			write(99,*),'cond_mixed .ne. 1,2 and 3. Subr. Dropshaft_general'
			call endprog
		endif		
	endif
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	!fvec(3) represents the momentum/mass storage relation	
!	con1 = -g*Ares*x(3) !gravity
!	con2 = g*Ares*x(1) !pressure force	
!	con4 = con3*x(3)*(x(3)+x(2))/2d0*abs((x(3)+x(2))/2d0) !friction
!	con4 = 0d0 !friction is neglected
!	con5 = ((Qinf_new+Qinf_old)/2d0)**2d0/Ares	
!	con6 = (Qinf_new+Qinf_old-x(3))*(x(3)-yudrop_n(r))/dt 	
!	con7 = x(3)*(x(3)-2d0*yudrop_n(r)+yudrop_n_1(r))/dt**2d0
!	con8 = ((x(3)-yudrop_n(r))/dt)**2d0
!	temp1 = -(con6-2d0*Ares*(con7+con8))

	!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!	con1 = -g*Ares*(x(3)+yudrop_n(r))/2d0 !gravity
!	con2 = g*Ares*(x(1)+x(1))/2d0 !pressure force
!	con3 = param14
!	Qav = (x(2)+x(3))/2d0
!	Hav = (x(3)+yudrop_n(r))/2d0
!	con4 = con3*Hav*Qav*abs(Qav) !friction modified for upstream
!	con4 = 0d0
!	Qs = (Qinf_new+Qinf_old)/2d0
!	con5 = -(x(2)*x(3)- x(3)*yudrop_n(r))/dt !modified for upstream
!	fvec(2) = con1 + con2 + con4 - con5 
	!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	!Storage equation
	!if (Nodetype(R,1) == 2)then !outflowing
	!	!sign for Qb is negative for upstream reservoir
	!	temp1 = 5d-1*(- Qb_oldIA(1) - x(3)) 			
	!Elseif (Nodetype(R,1) == 1)then !inflowing
	!	temp1 = 5d-1*(Qb_oldIA(1) + x(3)) 
	!Endif

	if (Nodetype(R,1) == 2)then !outflowing
		!sign for Qb is negative for upstream reservoir
		temp1 =  - x(3)
	Elseif (Nodetype(R,1) == 1)then !inflowing
		temp1 = x(3)
	Endif

	temp3 = 5d-1*(Qinf_new+Qinf_old)
	temp4 = Ares/dt*(x(2)-yres_jun_old(R)) 		
	fvec(3) = temp3+temp1-temp4
	return
	end
	!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
